<id>
din1031:MultilingualAgreements
</id>

<version>
1.0.1
</version>

<edit file>
$sourcedir/ManageRegistration.php
</edit file>

<search for>
		'agreement' => array('EditAgreement', 'admin_forum'),
</search for>

<replace>
		'agreement' => array('EditAgreement', 'admin_forum'),
		//Overwrite the Setting above with the new one :D
		'agreement' => array('EditMultiLangAgreement', 'admin_forum'),
</replace>

<search for>
// Set reserved names/words....
</search for>

<replace>
// Multilinguale Managment for Agreements :D
function EditMultiLangAgreement()
{
	global $txt, $sourcedir, $boarddir, $context, $modSettings, $db_prefix, $settings, $func;
	
	require_once($sourcedir.'/Subs-Post.php');
	if (isset($_POST['save']))
	{
		checkSession();
		updateSettings(array('requireAgreement' => !empty($_POST['requireAgreement'])));

		//Prepare the data :D
		foreach($_POST['agreement'] as $language => $items) {
			preparsecode($items['text']);
			$agreement = $items['text'];
			$enable = !empty($items['enable']) ? 1 : 0;
			//Okay Insert it into the db :D
			db_query("
				REPLACE INTO {$db_prefix}agreement
					(language, agreement, enable)
				VALUES ('$language', '$agreement', $enable)", __FILE__, __LINE__);
		}
		redirectexit('action=regcenter;sa=agreement');
	}

	$context['agreements'] = array();
	$context['languages'] = array();
	$context['require_agreement'] = !empty($modSettings['requireAgreement']);
	
	$request = db_query("SELECT * FROM {$db_prefix}agreement", __FILE__, __LINE__);
	while($row = mysql_fetch_assoc($request)) {
		$context['agreements'][$row['language']] = array(
			'name' => $func['ucwords']($row['language']),
			'text' => un_preparsecode(preg_replace('~<br(?: /)?' . '>~i', "\n", $row['agreement'])),
			'enable' => !empty($row['enable'])
		);
	}
	mysql_free_result($request);
	
	if(empty($context['agreements'])) {
		// Get the current agreement.
		$context['agreements']['english'] = array(
			'name' => 'English',
			'text' => (file_exists($boarddir . '/agreement.txt') ? htmlspecialchars(file_get_contents($boarddir . '/agreement.txt')) : ''),
			'enable' => !empty($modSettings['requireAgreement']),
		);
	}

	//Let's see, which language is missing, fill it with empty strings *g*
	$language_directories = array(
		$settings['default_theme_dir'] . '/languages',
		$settings['actual_theme_dir'] . '/languages',
	);
	if (!empty($settings['base_theme_dir']))
		$language_directories[] = $settings['base_theme_dir'] . '/languages';
	$language_directories = array_unique($language_directories);

	foreach ($language_directories as $language_dir)
	{
		// Can't look in here... doesn't exist!
		if (!file_exists($language_dir))
			continue;

		$dir = dir($language_dir);
		while ($entry = $dir->read())
		{
			// Look for the index language file....
			if (preg_match('~^index\.(.+)\.php$~', $entry, $matches) == 0)
				continue;
			
			$name = strtr($matches[1], array('_' => ' ', '-utf8' => ''));
	
			if($name != 'english')
				$context['languages'][] = $name;
	
			if(isset($context['agreements'][$name]))
				continue;
			
			$context['agreements'][$name] = array(
				'name' => $func['ucwords']($name),
				'text' => '',
				'enable' => false,
			);
		}
		$dir->close();
	}
	$context['languages'] = array_unique($context['languages']);
	$context['sub_template'] = 'edit_multi_lang_agreement';
	$context['page_title'] = $txt['smf11'];
}

// Set reserved names/words....
</replace>

<edit file>
$sourcedir/Register.php
</edit file>

<search for>
	// If you have to agree to the agreement, it needs to be fetched from the file.
	if ($context['require_agreement'])
		$context['agreement'] = file_exists($boarddir . '/agreement.txt') ? parse_bbc(file_get_contents($boarddir . '/agreement.txt'), true, 'agreement') : '';
</search for>

<replace>
	// If you have to agree to the agreement, it needs to be fetched from the file.
	// Sorry but i need to change it to database Version ;P
	if ($context['require_agreement']) {
		$context['agreements'] = array();
		//Load the Current Agreements :D
		$request = db_query("SELECT * FROM {$db_prefix}agreement WHERE enable = 1", __FILE__, __LINE__);
		while($row = mysql_fetch_assoc($request)) {
			$context['agreements'][$row['language']] = array(
				'name' => $func['ucwords']($row['language']),
				'text' => $row['agreement'],
				'enable' => !empty($row['enable'])
			);
		}
		mysql_free_result($request);
		
		//Load the Orginal ;D (As long nothing else is there :D
		if(empty($context['agreements']))
			$context['agreement'] = file_exists($boarddir . '/agreement.txt') ? parse_bbc(file_get_contents($boarddir . '/agreement.txt'), true, 'agreement') : '';
		else {
			$selectedLanguage = empty($_SESSION['language']) ? $language : $_SESSION['language'];
			$selectedLanguage = strtr($selectedLanguage, array('_' => ' ', '-utf8' => ''));
			//User Language?
			if(isset($context['agreements'][$selectedLanguage])) 
				$context['agreement'] = parse_bbc($context['agreements'][$selectedLanguage]['text']);
			//Okay English?
			elseif(isset($context['agreements']['english']))
				$context['agreement'] = parse_bbc($context['agreements']['english']['text']);
			//WHAT no Standard! How did you do this ;P
			else
				$context['agreement'] = file_exists($boarddir . '/agreement.txt') ? parse_bbc(file_get_contents($boarddir . '/agreement.txt'), true, 'agreement') : '';
		}
	}
</replace>

<edit file>
$themedir/Register.template.php
</edit file>

<search for>
// Form for editing the agreement shown for people registering to the forum.
</search for>

<replace>
// Form for editing the multilingual agreement shown for people registering to the forum.
function template_edit_multi_lang_agreement()
{
	global $context, $settings, $options, $scripturl, $txt;

	// Just a big box to edit the text file ;). <- More than one box ;D
	echo '
	<form action="', $scripturl, '?action=regcenter" method="post" accept-charset="', $context['character_set'], '">
		<table border="0" cellspacing="0" cellpadding="4" align="center" width="80%" class="tborder">
			<tr class="titlebg">
				<td align="center">', $txt['smf11'], '</td>
			</tr>';

	echo '
			<tr class="windowbg2">
				<td align="center" style="padding-bottom: 1ex; padding-top: 2ex;">
					<label for="requireAgreement"><input type="checkbox" name="requireAgreement" id="requireAgreement"', $context['require_agreement'] ? ' checked="checked"' : '', ' value="1" /> ', $txt[584], '.</label><br />';

	// Show the actual agreements in an oversized text boxes. (Allow a open and close ;D)
	foreach($context['agreements'] as $language => $agree) {
		echo '
					<a name="'.$language.'"></a>
					<p align="left"><b><a href="#'.$language.'" onclick="return open'.$language.'Item();">'.$txt['agreements_language'].': '.$agree['name'].'</a></b></p>
					<div id="'.$language.'Item" style="display:block;">
					<textarea cols="70" rows="10" name="agreement['.$language.'][text]" style="width: 94%; margin-bottom: 1ex;">', $agree['text'], '</textarea><br />';
		//English is the Master this must be on! everything else can be done like the admin wish ;D
		if($language == 'english') 
			echo '
					<input type="hidden" name="agreement['.$language.'][enable]" value="1" /> ', $txt['agreements_enable_english'], '<br />';
		else
			echo '
					<label for="'.$language.'"><input type="checkbox" name="agreement['.$language.'][enable]" id="'.$language.'"', $agree['enable'] ? ' checked="checked"' : '', ' value="1" /> ', $txt['agreements_enable'], '.</label><br />';
		//End the Item :D
		echo '
					</div><hr />';

		//Add Javascript for this Item :)
		echo '
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						//This Skript is only for Opening and Closing the group select list
						var '.$language.'ItemStatus = false;
						
						function open'.$language.'Item() {
							if('.$language.'ItemStatus) {
								'.$language.'ItemStatus = false;
								document.getElementById("'.$language.'Item").style.display = "block";
							}
							else {
								'.$language.'ItemStatus = true;
								document.getElementById("'.$language.'Item").style.display = "none";
							}
						
							return false;
						}
						'.($language != 'english' ? 'open'.$language.'Item();' : '').'
					// ]]></script>';
		}

	echo '
					<br /><br />
					<input type="submit" value="', $txt[10], '" />
					<input type="hidden" name="save" value="save" />
					<input type="hidden" name="sa" value="agreement" />
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

// Form for editing the agreement shown for people registering to the forum.
</replace>

